package com.boman.system.api;

import com.boman.domain.SysUser;
import com.boman.domain.constant.ServiceNameConstants;
import com.boman.domain.dto.AjaxResult;
import com.boman.domain.dto.R;
import com.boman.system.api.factory.RemoteUserFallbackFactory;
import com.boman.system.api.model.LoginUser;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import java.util.List;

/**
 * 登录记录
 * 
 * @author ruoyi
 */
@FeignClient(contextId = "remoteLoginInforService", value = ServiceNameConstants.SYSTEM_SERVICE)
public interface RemoteLoginInforService
{
    /**
     * 判断该用户名最后登录时间是否超过15天,返回值 大于0 则15天内登录过
     * @param userName
     * @return
     */
    @GetMapping("/logininfor/getLastLogininfor/{userName}")
    Integer getLastLogininfor(@PathVariable("userName") String userName);
}
