package com.boman.web.core.Thread;
/**
 * @author tjf
 * @Date: 2022/07/13/15:44
 */

import java.util.ArrayList;
import java.util.List;

/**
 * @author tjf
 * @Date: 2022/07/13/15:44
 */
public class BranchThreadUtils {
    /**
     * 计算出需要多少个线程
     *
     * @param list
     * @param pageSize
     * @param <T>
     * @return
     */
    public static <T> List<List<T>> splitList(List<T> list, int pageSize) {
        int listSize = list.size();
        int page = (listSize + (pageSize - 1)) / pageSize;
        List<List<T>> listArray = new ArrayList<List<T>>();
        for (int i = 0; i < page; i++) {
            List<T> subList = new ArrayList<T>();
            for (int j = 0; j < listSize; j++) {
                //获取当前循环的下标是多少
                int pageIndex = ((j + 1) + (pageSize - 1)) / pageSize;
                //判断当前的下标是否是对应线程的取值内
                if (pageIndex == (i + 1)) {
                    subList.add(list.get(j));
                }
                //判断当前的下标是否是对应线程的最大取值
                if ((j + 1) == ((i + 1) * pageSize)) {
                    break;
                }
            }
            listArray.add(subList);
        }
        return listArray;
    }
}
