package com.boman.web.core.Thread;
/**
 * @author tjf
 * @Date: 2022/07/13/15:45
 */

import com.aliyun.dysmsapi20170525.models.SendBatchSmsRequest;
import com.aliyun.dysmsapi20170525.models.SendBatchSmsResponse;
import com.boman.common.core.exception.CustomException;
import com.boman.common.core.utils.SecurityUtils;
import com.boman.common.core.utils.StringUtils;
import com.boman.web.core.domain.SendSms;
import com.boman.web.core.mapper.SendSmsMapper;
import com.boman.web.core.utils.SendBatchSmsUtils;
import org.springframework.beans.factory.annotation.Autowired;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

/**
 * @author tjf
 * @Date: 2022/07/13/15:45
 */
public class SmsThread extends Thread {
    private List<SendSms> smsList;

    public SmsThread(List<SendSms> smsList) {
        this.smsList = smsList;
    }

    public List<SendSms> getSmsList() {
        return smsList;
    }

    public void setSmsList(List<SendSms> smsList) {
        this.smsList = smsList;
    }

    static final String TEMPLATE_CODE = "SMS_245245018";
    static final String TEMPLATE_CODE_NOTICE = "SMS_245705093";

    /**
     * 具体发送短信的接口多线程,模板是中考信息修改通知
     * 如果要发别的模板,需要修改模板名称和增加替换参数
     */
    @Override
    public void run() {
        if (StringUtils.isNull(smsList) || smsList.size() == 0) {
            throw new CustomException("导入数据不能为空！");
        }
        int maxNums = 100; //每次最多发送100条，我们一次批量发100条
        int times = 0;// 循环几个100  用List的长度 除 100
        int size = 0; //
        String operName = "admin";
        List<String> phoneList = new ArrayList<>();
        //List<String> templateList = new ArrayList<>();
        List<String> signNameList = new ArrayList<>();
        StringBuffer signNameJson;
        StringBuffer phoneNumberJson;
        //StringBuffer templateParamJson;
        //返回提示
        String backResult = "";
        size = smsList.size();
        if (size < maxNums) {
            times = 1;
        } else {
            times = (size - 1) / maxNums + 1; //为什么要-1 因为如果是200的时候，理论上次数应该是2，而不是3，如果是101，那么次数也是2，这样就保证次数准确。
        }

        for (int j = 0; j < times; j++) {
            if (j > 0 && (j * maxNums + 1 > size)) { //边界判定，如果刚好是100条，那么times的值为2，这时候j 为1的时候 101 大于100结束循环，100条以内不生效
                break;
            } else {
                phoneNumberJson = new StringBuffer();
                signNameJson = new StringBuffer();
                //templateParamJson = new StringBuffer();
                phoneNumberJson.append("[");
                signNameJson.append("[");
                //templateParamJson.append("[");
                for (int k = j * maxNums; k < size && k < (j + 1) * maxNums; k++) {
                    // 防止有空行，手机号是必须要有的
                    String phone = smsList.get(k).getPhone();
                    if (StringUtils.isEmpty(phone)) {
                        continue;
                    }
                    phoneNumberJson.append("\"" + smsList.get(k).getPhone() + "\",");
                    signNameJson.append("\"潜山市数据资源局\",");
                    //templateParamJson.append("{\"ticketId\":\"" + smsList.get(k).getTicketId() + "\",\"name\":\"" + smsList.get(k).getName() + "\",\"result\":\"" + smsList.get(k).getResult() + "\"},");

                }
                phoneNumberJson.deleteCharAt(phoneNumberJson.length() - 1);//移除最后一个逗号字符，
                signNameJson.deleteCharAt(signNameJson.length() - 1);
                //templateParamJson.deleteCharAt(templateParamJson.length() - 1);//移除最后一个逗号字符
                phoneNumberJson.append("]");
                signNameJson.append("]");
                //templateParamJson.append("]");
                phoneList.add(phoneNumberJson.toString());
                signNameList.add(signNameJson.toString());
                //templateList.add(templateParamJson.toString());
            }
            //组装请求对象
            if (times == phoneList.size()) {
                for (int i = 0; i < times; i++) {
                    long startTimeSql = System.currentTimeMillis();
                    SendBatchSmsRequest sendBatchSmsRequest = new SendBatchSmsRequest();
                    //组装电话号码
                    sendBatchSmsRequest.setPhoneNumberJson(phoneList.get(i));
                    //签名名称
                    sendBatchSmsRequest.setSignNameJson(signNameList.get(i));
                    //替换参数
                    //sendBatchSmsRequest.setTemplateParamJson(templateList.get(i));
                    //固定的模板名称
                    sendBatchSmsRequest.setTemplateCode(TEMPLATE_CODE_NOTICE);
                    long endTimeSql = System.currentTimeMillis() - startTimeSql;
                    System.out.println("线程" + Thread.currentThread().getId()+"执行批量下发短信通知计算:" + (i+1) + "次,时间" + endTimeSql + "ms");
                    long startTimeSend = System.currentTimeMillis();
                    SendBatchSmsResponse sendBatchSmsResponse = SendBatchSmsUtils.sendBatchSms(sendBatchSmsRequest);
                    long endTimeSend = System.currentTimeMillis() - startTimeSend;
                    System.out.println("线程" + Thread.currentThread().getId()+"执行批量下发短信通知接口请求:" + (i+1) + "次,时间"+ endTimeSend + "ms");
                    SendSms sendSms = new SendSms();
                    if (sendBatchSmsResponse != null) {
                        String code = sendBatchSmsResponse.getBody().getCode();
                        if (sendBatchSmsResponse.getBody().getCode() != null && "OK".equals(code)) {
                            //批量请求发送短信成功
                            System.out.println("批量短信发送成功：" + phoneList.get(i).split(",").length + "条");
                            backResult = backResult + "第" + i + "次批量成功  ";
                        } else {
                            System.out.println("批量短信发送失败！");
                            backResult = backResult + "第" + i + "次批量失败  ";
                        }
                    }
                }
            }
        }
    }
}
