package com.boman.web.core.controller;

import cn.hutool.core.date.DateUtil;
import cn.hutool.http.HttpRequest;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.boman.common.core.utils.StringUtils;
import com.boman.domain.constant.ProxyConstants;
import com.boman.domain.dto.AjaxResult;
import com.boman.web.core.utils.GjzwfwptSignUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 全国一体化政务服务平台接口
 * 安徽省安庆市潜山县不动产登记中心
 * @author ZS
 *
 */
@Api(description = "全国一体化政务服务平台接口【安徽省安庆市潜山县不动产登记中心】")
@RestController
@RequestMapping("/country/qsbdc")
@CrossOrigin
public class CountryProxyQsBdcController {
    //国家卫生健康委_国家出生医学证明查询数据接口
    @ApiOperation(value = "国家卫生健康委_国家出生医学证明查询数据接口")
    @GetMapping("/gjcsyyzmcxsjjk")
    public String gjcsyyzmcxsjjk(
            @ApiParam(value = "请求机构编码") @RequestParam(required = false) String requestOrgCode,
            @ApiParam(value = "请求机构组织机构名称") @RequestParam(required = false) String requestOrgName,
            @ApiParam(value = "出生编号") @RequestParam String BirthCode,
            @ApiParam(value = "母亲姓名") @RequestParam String MomName,
            @ApiParam(value = "母亲身份证号") @RequestParam String MomIdCode) {
        String appkey = "d33449a37af825ea4ae9c3a4fb169bb8"; //发送方签名
        String gjzwfwpt_sign = GjzwfwptSignUtil.getGjzwfwptSign(ProxyConstants.SID.GJCSYYZMCXSJJK,
                ProxyConstants.RID.QSBDC_RID, appkey);
        String gjzwfwpt_rtime = GjzwfwptSignUtil.getGjzwfwptRtime(appkey);
        // 接口调用
        //Map<String, Object> postParams = new HashMap<>();
        //组装参数
        //公共请求参数
//		postParams.put("version","1.0");
        //请求查询条件参数
        // 总体信息
        String requestDate = DateUtil.now(); //请求时间
        // 业务参数信息
        String body = "<soapenv:Envelope xmlns:soapenv=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:web=\"http://webservice.tongtech.com/\">\r\n"
                + "    <soapenv:Header/>\r\n"
                + "    <soapenv:Body>\r\n"
                + "        <web:getBirthInfo>\r\n"
                + "            <username>GJCSZM</username>\r\n"
                + "            <password>888888</password>\r\n"
                + "            <selectXml>\r\n"
                + "                &lt;?xml version=\"1.0\" encoding=\"UTF-8\" ?&gt;\r\n"
                + "                &lt;MDEML  templateVersion=\"1.0\"&gt;\r\n"
                + "                &lt;requestinfo&gt;\r\n"
                + "                &lt;requestDate&gt;" + requestDate + "&lt;/requestDate&gt;\r\n"
                + "                &lt;requestOrgCode&gt;" + requestOrgCode + "&lt;/requestOrgCode&gt;\r\n"
                + "                &lt;requestOrgName&gt;" + requestOrgName + "&lt;/requestOrgName&gt;\r\n"
                + "                &lt;/requestinfo&gt;\r\n"
                + "                &lt;body&gt;\r\n"
                + "                &lt;data&gt;\r\n"
                + "                &lt;BirthCode&gt;" + BirthCode + "&lt;/BirthCode&gt;\r\n"
                + "                &lt;MomName&gt;" + MomName + "&lt;/MomName&gt;\r\n"
                + "                &lt;MomIdCode&gt;" + MomIdCode + "&lt;/MomIdCode&gt;\r\n"
                + "                &lt;/data&gt;\r\n"
                + "                &lt;/body&gt;\r\n"
                + "                &lt;/MDEML&gt;\r\n"
                + "            </selectXml>\r\n"
                + "        </web:getBirthInfo>\r\n"
                + "    </soapenv:Body>\r\n"
                + "</soapenv:Envelope>";
        return postServiceRequest(ProxyConstants.SID.GJCSYYZMCXSJJK, gjzwfwpt_sign, gjzwfwpt_rtime, body);
    }

    //民政部_殡葬服务火化信息查询
    @ApiOperation(value = "民政部_殡葬服务火化信息查询")
    @GetMapping("/bzfwhhxxcx")
    public AjaxResult bzfwhhxxcx(
            @ApiParam(value = "姓名") @RequestParam String name,
            @ApiParam(value = "身份证号") @RequestParam String id_card) {

        if(StringUtils.isEmpty(name) || StringUtils.isEmpty(id_card)){
            AjaxResult.error("请将参数填写完整");
        }

        String appkey = "c40c921bea411f13377ea3548e6d1686"; //发送方签名
        String gjzwfwpt_sign = GjzwfwptSignUtil.getGjzwfwptSign(ProxyConstants.SID.BZFWHHXXCX,
                ProxyConstants.RID.QSBDC_RID, appkey);
        String gjzwfwpt_rtime = GjzwfwptSignUtil.getGjzwfwptRtime(appkey);
        // 接口调用
        Map<String, Object> postParams = new HashMap<>();
        //组装参数
        //公共请求参数
        postParams.put("version","1.0");
        postParams.put("name", name);
        postParams.put("id_card", id_card);
        //请求查询条件参数
        JSONObject params = new JSONObject();
        params.putOnce("name", name);
        params.putOnce("id_card", id_card);
        postParams.put("biz_content", params.toString());
        String json = postRequest(ProxyConstants.SID.BZFWHHXXCX, gjzwfwpt_sign, gjzwfwpt_rtime, postParams);
        Map<String, Object> jsonObject = JSONUtil.toBean(json,HashMap.class);
        Map<String, Object> map = (Map<String, Object>) jsonObject.get("result");
        return AjaxResult.success("成功",map.get("data"));

    }
    

    // 民政部_婚姻登记信息核验(个人)
    @ApiOperation(value = "民政部_婚姻登记信息核验(个人)")
    @GetMapping("/hydjxxhygr")
    public AjaxResult hydjxxhygr(
            @ApiParam(value = "男/女方姓名") @RequestParam String name_man,
            @ApiParam(value = "男/女方身份证件号码") @RequestParam String cert_num_man) {
        if(StringUtils.isEmpty(name_man) || StringUtils.isEmpty(cert_num_man)){
            AjaxResult.error("请将参数填写完整");
        }
        String appkey = "e72f935d839db74e407ca9fa13cc78b7"; //发送方签名
        String gjzwfwpt_sign = GjzwfwptSignUtil.getGjzwfwptSign(ProxyConstants.SID.HYDJXXHYGR,
                ProxyConstants.RID.QSBDC_RID, appkey);
        String gjzwfwpt_rtime = GjzwfwptSignUtil.getGjzwfwptRtime(appkey);
        // 接口调用
        Map<String, Object> postParams = new HashMap<>();
        //组装参数
        //公共请求参数
        postParams.put("version","1.0");
//		postParams.put("cert_num_man", "34");
//		postParams.put("name_man", "1");
        postParams.put("name_man", name_man);
        postParams.put("cert_num_man", cert_num_man);
        //请求查询条件参数
        JSONObject params = new JSONObject();
//		params.put("name_man", "");
//		params.put("cert_num_man", "34");
        params.putOnce("name_man", name_man);
        params.putOnce("cert_num_man", cert_num_man);
        postParams.put("biz_content", params.toString());
        String json = postRequest(ProxyConstants.SID.HYDJXXHYGR, gjzwfwpt_sign, gjzwfwpt_rtime, postParams);

        List<Map<String, Object>> listMap = new ArrayList<>();
        Map<String, Object> jsonObject = JSONUtil.toBean(json,HashMap.class);
        Map<String, Object> map = (Map<String, Object>) jsonObject.get("result");
        if(map!= null){
            listMap.add(map);
        }
        return AjaxResult.success("成功",listMap);
    }

    //	民政部_婚姻登记信息核验(个人)（新）
    @ApiOperation(value = "民政部_婚姻登记信息核验(个人)（新）")
    @GetMapping("/hydjxxhygrx")
    public AjaxResult hydjxxhygrx(
            @ApiParam(value = "男/女方姓名") @RequestParam String name_man,
            @ApiParam(value = "男/女方身份证件号码") @RequestParam String cert_num_man) {
        if(StringUtils.isEmpty(name_man) || StringUtils.isEmpty(cert_num_man)){
            AjaxResult.error("请将参数填写完整");
        }
        String appkey = "e6f421141633fa9dce093f17e7763112"; //发送方签名
        String gjzwfwpt_sign = GjzwfwptSignUtil.getGjzwfwptSign(ProxyConstants.SID.HYDJXXHYGRX,
                ProxyConstants.RID.QSBDC_RID, appkey);
        String gjzwfwpt_rtime = GjzwfwptSignUtil.getGjzwfwptRtime(appkey);
        System.out.println("gjzwfwpt_rtime"+gjzwfwpt_rtime);
        // 接口调用
        Map<String, Object> postParams = new HashMap<>();
        //组装参数
        //公共请求参数
        postParams.put("version","1.0");
        //请求查询条件参数
        JSONObject params = new JSONObject();
//		params.put("name_man", "xxx");
//		params.put("cert_num_man", "34");
        params.putOnce("name_man", name_man);
        params.putOnce("cert_num_man", cert_num_man);
        postParams.put("biz_content", params.toString());
        String json = postRequest(ProxyConstants.SID.HYDJXXHYGRX, gjzwfwpt_sign, gjzwfwpt_rtime, postParams);
        List<Map<String, Object>> listMap = new ArrayList<>();
        Map<String, Object> jsonObject = JSONUtil.toBean(json,HashMap.class);
        Map<String, Object> map = (Map<String, Object>) jsonObject.get("biz_data");
        if(map.get("result")!=null){
            listMap.add((Map<String, Object>)map.get("result"));
        }
        return AjaxResult.success("成功",listMap);
    }

    //民政部_婚姻登记信息核验(双方)
    @ApiOperation(value = "民政部_婚姻登记信息核验(双方)")
    @GetMapping("/hydjxxhysf")
    public AjaxResult hydjxxhysf(
            @ApiParam(value = "男方姓名") @RequestParam String name_man,
            @ApiParam(value = "男方身份证件号码") @RequestParam String cert_num_man,
            @ApiParam(value = "女方姓名") @RequestParam String name_woman,
            @ApiParam(value = "女方身份证件号码") @RequestParam String cert_num_woman) {
        if(StringUtils.isEmpty(name_man) || StringUtils.isEmpty(cert_num_man)){
            AjaxResult.error("请将参数填写完整");
        }
        if(StringUtils.isEmpty(name_woman) || StringUtils.isEmpty(cert_num_woman)){
            AjaxResult.error("请将参数填写完整");
        }
        String appkey = "30d5c47587af585d8acec5cb68b18ba9"; //发送方签名
        String gjzwfwpt_sign = GjzwfwptSignUtil.getGjzwfwptSign(ProxyConstants.SID.HYDJXXHYSF,
                ProxyConstants.RID.QSBDC_RID, appkey);
        String gjzwfwpt_rtime = GjzwfwptSignUtil.getGjzwfwptRtime(appkey);
        // 接口调用
        Map<String, Object> postParams = new HashMap<>();
        //组装参数
        //公共请求参数
        postParams.put("version","");
        postParams.put("name_man", name_man);
        postParams.put("cert_num_man", cert_num_man);
        postParams.put("name_woman", name_woman);
        postParams.put("cert_num_woman", cert_num_woman);
        //请求查询条件参数
        JSONObject params = new JSONObject();
        params.putOnce("name_man", name_man);
        params.putOnce("cert_num_man", cert_num_man);
        params.putOnce("name_woman", name_woman);
        params.putOnce("cert_num_woman", cert_num_woman);
        postParams.put("biz_content", params.toString());
        String json = postRequest(ProxyConstants.SID.HYDJXXHYSF, gjzwfwpt_sign, gjzwfwpt_rtime, postParams);
        List<Map<String, Object>> listMap = new ArrayList<>();
        Map<String, Object> jsonObject = JSONUtil.toBean(json,HashMap.class);
        Map<String, Object> map = (Map<String, Object>) jsonObject.get("biz_data");
        if(map.get("result")!=null){
            listMap.add((Map<String, Object>)map.get("result"));
        }
        return AjaxResult.success("成功",listMap);

    }

    //民政部_婚姻登记信息核验(双方)(新)
    @ApiOperation(value = "民政部_婚姻登记信息核验(双方)(新)")
    @GetMapping("/hydjxxhysfx")
    public String hydjxxhysfx(
            @ApiParam(value = "男方姓名") @RequestParam String name_man,
            @ApiParam(value = "男方身份证件号码") @RequestParam String cert_num_man,
            @ApiParam(value = "女方姓名") @RequestParam String name_woman,
            @ApiParam(value = "女方身份证件号码") @RequestParam String cert_num_woman) {

        if(StringUtils.isEmpty(name_man) || StringUtils.isEmpty(cert_num_man)){
            AjaxResult.error("请将参数填写完整");
        }
        if(StringUtils.isEmpty(name_woman) || StringUtils.isEmpty(cert_num_woman)){
            AjaxResult.error("请将参数填写完整");
        }

        String appkey = "76746be3e436eb6ce84b63814ee9cd03"; //发送方签名
        String gjzwfwpt_sign = GjzwfwptSignUtil.getGjzwfwptSign(ProxyConstants.SID.HYDJXXHYSFX,
                ProxyConstants.RID.QSBDC_RID, appkey);
        String gjzwfwpt_rtime = GjzwfwptSignUtil.getGjzwfwptRtime(appkey);
        // 接口调用
        Map<String, Object> postParams = new HashMap<>();
        //组装参数
        //公共请求参数
        postParams.put("version","1.0");
        //请求查询条件参数
        JSONObject params = new JSONObject();
//		params.put("name_man", "周林松");
//		params.put("cert_num_man", "342622760910565");
//		params.put("name_woman", "邢应芝");
//		params.put("cert_num_woman", "342622780503568");
        params.putOnce("name_man", name_man);
        params.putOnce("cert_num_man", cert_num_man);
        params.putOnce("name_woman", name_woman);
        params.putOnce("cert_num_woman", cert_num_woman);
        postParams.put("biz_content", params.toString());
        return postRequest(ProxyConstants.SID.HYDJXXHYSFX, gjzwfwpt_sign, gjzwfwpt_rtime, postParams);
    }

    //民政部_民办非企业单位登记证书查询（新）
    @ApiOperation(value = "民政部_民办非企业单位登记证书查询（新）")
    @GetMapping("/mbfqydwdjzscxxx")
    public AjaxResult mbfqydwdjzscxxx(
            @ApiParam(value = "唯一社会信用代码") @RequestParam String usc_code,
            @ApiParam(value = "组织名称") @RequestParam String org_name) {

        if(StringUtils.isEmpty(usc_code) || StringUtils.isEmpty(org_name)){
            AjaxResult.error("请将参数填写完整");
        }

        String appkey = "8fcc6c4b9ea44aa6d63096db5cfed126"; //发送方签名
        String gjzwfwpt_sign = GjzwfwptSignUtil.getGjzwfwptSign(ProxyConstants.SID.MBFQYDWDJZSCXXX,
                ProxyConstants.RID.QSBDC_RID, appkey);
        String gjzwfwpt_rtime = GjzwfwptSignUtil.getGjzwfwptRtime(appkey);
        // 接口调用
        Map<String, Object> postParams = new HashMap<>();
        //组装参数
        //公共请求参数
        postParams.put("version","");
        //请求查询条件参数
        JSONObject params = new JSONObject();
        params.putOnce("usc_code", usc_code);
        params.putOnce("org_name", org_name);
        postParams.put("biz_content", params.toString());


        String json = postRequest(ProxyConstants.SID.MBFQYDWDJZSCXXX, gjzwfwpt_sign, gjzwfwpt_rtime, postParams);

        Map<String, Object> jsonObject = JSONUtil.toBean(json,HashMap.class);
        Map<String, Object> map = (Map<String, Object>) jsonObject.get("biz_data");

        return AjaxResult.success("成功",map.get("rows"));
    }

    //民政部_社会组织信息查询服务接口（新）
    @ApiOperation(value = "民政部_社会组织信息查询服务接口（新）")
    @GetMapping("/shzzxxcxfwjkx")
    public AjaxResult shzzxxcxfwjkx(
            @ApiParam(value = "唯一社会信用代码") @RequestParam String usc_code,
            @ApiParam(value = "社会组织名称") @RequestParam String org_name) {

        if(StringUtils.isEmpty(usc_code) || StringUtils.isEmpty(org_name)){
            AjaxResult.error("请将参数填写完整");
        }

        String appkey = "45596d6b8d24c9d51c037d77ff6451d6"; //发送方签名
        String gjzwfwpt_sign = GjzwfwptSignUtil.getGjzwfwptSign(ProxyConstants.SID.SHZZXXCXFWJKX,
                ProxyConstants.RID.QSBDC_RID, appkey);
        String gjzwfwpt_rtime = GjzwfwptSignUtil.getGjzwfwptRtime(appkey);
        // 接口调用
        Map<String, Object> postParams = new HashMap<>();
        //组装参数
        //公共请求参数
        postParams.put("version","");
        //请求查询条件参数
        JSONObject params = new JSONObject();
//		params.put("usc_code", "521000000886907386");
//		params.put("org_name", "xxx");
        params.putOnce("usc_code", usc_code);
        params.putOnce("org_name", org_name);
        postParams.put("biz_content", params.toString());

        String json = postRequest(ProxyConstants.SID.SHZZXXCXFWJKX, gjzwfwpt_sign, gjzwfwpt_rtime, postParams);

        Map<String, Object> jsonObject = JSONUtil.toBean(json,HashMap.class);
        Map<String, Object> map = (Map<String, Object>) jsonObject.get("biz_data");

        return AjaxResult.success("成功",map.get("rows"));
    }

    //民政部_民办非企业名称变更登记记录查询（新）
    @ApiOperation(value = "民政部_民办非企业名称变更登记记录查询（新）")
    @GetMapping("/mbfqymcbgdjjlcxx")
    public AjaxResult mbfqymcbgdjjlcxx(@ApiParam(value = "统一社会信用代码") @RequestParam String tyxydm) {

        if(StringUtils.isEmpty(tyxydm)){
            AjaxResult.error("请将参数填写完整");
        }

        String appkey = "3268f9654271addb14e01868f4350c5d"; //发送方签名
        String gjzwfwpt_sign = GjzwfwptSignUtil.getGjzwfwptSign(ProxyConstants.SID.MBFQYMCBGDJJLCXX,
                ProxyConstants.RID.QSBDC_RID, appkey);
        String gjzwfwpt_rtime = GjzwfwptSignUtil.getGjzwfwptRtime(appkey);
        // 接口调用
        Map<String, Object> postParams = new HashMap<>();
        //组装参数
        //公共请求参数
        postParams.put("version","");
        //请求查询条件参数
        JSONObject params = new JSONObject();
//		params.put("tyxydm", "521000000886907386");
        params.putOnce("tyxydm", tyxydm);
        postParams.put("biz_content", params.toString());

        String json = postRequest(ProxyConstants.SID.MBFQYMCBGDJJLCXX, gjzwfwpt_sign, gjzwfwpt_rtime, postParams);

        Map<String, Object> jsonObject = JSONUtil.toBean(json,HashMap.class);
        Map<String, Object> map = (Map<String, Object>) jsonObject.get("biz_data");
        return AjaxResult.success("成功",json);
        //return AjaxResult.success("成功",map.get("rows"));
    }

    //民政部_社会团体法人登记证书查询(新)
    @ApiOperation(value = "民政部_社会团体法人登记证书查询(新)")
    @GetMapping("/shttfrdjzscxx")
    public AjaxResult shttfrdjzscxx(
            @ApiParam(value = "唯一社会信用代码") @RequestParam String usc_code,
            @ApiParam(value = "组织名称") @RequestParam String org_name) {

        if(StringUtils.isEmpty(usc_code) || StringUtils.isEmpty(org_name)){
            AjaxResult.error("请将参数填写完整");
        }

        String appkey = "81d1f6c7b58b098b542c979d52411426"; //发送方签名
        String gjzwfwpt_sign = GjzwfwptSignUtil.getGjzwfwptSign(ProxyConstants.SID.SHTTFRDJZSCXX,
                ProxyConstants.RID.QSBDC_RID, appkey);
        String gjzwfwpt_rtime = GjzwfwptSignUtil.getGjzwfwptRtime(appkey);
        // 接口调用
        Map<String, Object> postParams = new HashMap<>();
        //组装参数
        //公共请求参数
        postParams.put("version","");
        //请求查询条件参数
        JSONObject params = new JSONObject();
//		params.put("usc_code", "521000000886907386");
//		params.put("org_name", "xxx");
        params.putOnce("usc_code", usc_code);
        params.putOnce("org_name", org_name);
        postParams.put("biz_content", params.toString());

        String json = postRequest(ProxyConstants.SID.SHTTFRDJZSCXX, gjzwfwpt_sign, gjzwfwpt_rtime, postParams);

        Map<String, Object> jsonObject = JSONUtil.toBean(json,HashMap.class);
        Map<String, Object> map = (Map<String, Object>) jsonObject.get("biz_data");
        return AjaxResult.success("成功",json);
        //return AjaxResult.success("成功",map.get("rows"));
    }

    //民政部_社会团体名称变更登记记录查询
    @ApiOperation(value = "民政部_社会团体名称变更登记记录查询")
    @GetMapping("/shttmcbgdjjlcx")
    public AjaxResult shttmcbgdjjlcx(@ApiParam(value = "统一社会信用代码") @RequestParam String tyxydm) {

        if(StringUtils.isEmpty(tyxydm)){
            AjaxResult.error("请将参数填写完整");
        }

        String appkey = "b90f6831c8ee12e45d21f0fa9421de9b"; //发送方签名
        String gjzwfwpt_sign = GjzwfwptSignUtil.getGjzwfwptSign(ProxyConstants.SID.SHTTMCBGDJJLCX,
                ProxyConstants.RID.QSBDC_RID, appkey);
        String gjzwfwpt_rtime = GjzwfwptSignUtil.getGjzwfwptRtime(appkey);
        // 接口调用
        Map<String, Object> postParams = new HashMap<>();
        //组装参数
        //公共请求参数
        postParams.put("version","");
        //请求查询条件参数
        JSONObject params = new JSONObject();
//		params.put("tyxydm", "521000000886907386");
        params.putOnce("tyxydm", tyxydm);
        postParams.put("biz_content", params.toString());

        String json = postRequest(ProxyConstants.SID.SHTTMCBGDJJLCX, gjzwfwpt_sign, gjzwfwpt_rtime, postParams);

        Map<String, Object> jsonObject = JSONUtil.toBean(json,HashMap.class);
        Map<String, Object> map = (Map<String, Object>) jsonObject.get("biz_data");
        return AjaxResult.success("成功",json);
        //return AjaxResult.success("成功",map.get("rows"));
    }

    // 民政部_涉外婚姻登记信息查询
    @ApiOperation("83民政部_涉外婚姻登记信息查询")
    @GetMapping("/swhydjxxcx")
    public AjaxResult swhydjxxcx(
            @ApiParam(value = "姓名") @RequestParam String name,
            @ApiParam(value = "身份证号") @RequestParam String cert_num) {

        if(StringUtils.isEmpty(name) || StringUtils.isEmpty(cert_num)){
            AjaxResult.error("请将参数填写完整");
        }

        String appkey = "d7ba1384d8c119823be782c20e2c3570"; //发送方签名
        String gjzwfwpt_sign = GjzwfwptSignUtil.getGjzwfwptSign(ProxyConstants.SID.SWHYDJXXCX,
                ProxyConstants.RID.QSBDC_RID, appkey);
        String gjzwfwpt_rtime = GjzwfwptSignUtil.getGjzwfwptRtime(appkey);
        // 接口调用
        Map<String, Object> postParams = new HashMap<>();
        //组装参数
        //公共请求参数
        postParams.put("version","1.0");
        //请求查询条件参数
        JSONObject params = new JSONObject();
        params.putOnce("name", name);
        params.putOnce("cert_num", cert_num);
        postParams.put("biz_content", params.toString());

        String json = postRequest(ProxyConstants.SID.SWHYDJXXCX, gjzwfwpt_sign, gjzwfwpt_rtime, postParams);

        Map<String, Object> jsonObject = JSONUtil.toBean(json,HashMap.class);
        Map<String, Object> map = (Map<String, Object>) jsonObject.get("biz_data");

        return AjaxResult.success("成功",map.get("result"));
    }

    //民政部_涉外婚姻登记信息核验（个人）（新）
    @ApiOperation(value = "民政部_涉外婚姻登记信息核验（个人）（新）")
    @GetMapping("/swhydjxxhygrx")
    public AjaxResult swhydjxxhygrx(
            @ApiParam(value = "姓名") @RequestParam String name,
            @ApiParam(value = "身份证号码") @RequestParam String cert_num) {

        if(StringUtils.isEmpty(name) || StringUtils.isEmpty(cert_num)){
            AjaxResult.error("请将参数填写完整");
        }

        String appkey = "ffd39c059ce081fd2debac66238d79cd"; //发送方签名
        String gjzwfwpt_sign = GjzwfwptSignUtil.getGjzwfwptSign(ProxyConstants.SID.SWHYDJXXHYGRX,
                ProxyConstants.RID.QSBDC_RID, appkey);
        String gjzwfwpt_rtime = GjzwfwptSignUtil.getGjzwfwptRtime(appkey);
        System.out.println("resultObj:" + gjzwfwpt_rtime);
        // 接口调用
        Map<String, Object> postParams = new HashMap<>();
        //组装参数
        //公共请求参数
        postParams.put("version","1.0");
        //请求查询条件参数
        JSONObject params = new JSONObject();
        params.putOnce("name", name);
        params.putOnce("cert_num", cert_num);
        postParams.put("biz_content", params.toString());

        String json = postRequest(ProxyConstants.SID.SWHYDJXXHYGRX, gjzwfwpt_sign, gjzwfwpt_rtime, postParams);

        Map<String, Object> jsonObject = JSONUtil.toBean(json,HashMap.class);
        Map<String, Object> map = (Map<String, Object>) jsonObject.get("biz_data");

        return AjaxResult.success("成功",map.get("result"));
    }

    //民政部_涉外婚姻登记信息核验(双方)
    @ApiOperation(value = "94民政部_涉外婚姻登记信息核验(双方) ")
    @GetMapping("/swhydjxxhysf")
    public String swhydjxxhysf(
            @ApiParam(value = "男方姓名") @RequestParam String name_man,
            @ApiParam(value = "男方身份证件号码") @RequestParam String cert_num_man,
            @ApiParam(value = "女方姓名") @RequestParam String name_woman,
            @ApiParam(value = "女方身份证件号码") @RequestParam String cert_num_woman) {

        if(StringUtils.isEmpty(name_man) || StringUtils.isEmpty(cert_num_man)){
            AjaxResult.error("请将参数填写完整");
        }
        if(StringUtils.isEmpty(name_woman) || StringUtils.isEmpty(cert_num_woman)){
            AjaxResult.error("请将参数填写完整");
        }


        String appkey = "2a1c4d5d191d692226aa3cd20861610b"; //发送方签名
        String gjzwfwpt_sign = GjzwfwptSignUtil.getGjzwfwptSign(ProxyConstants.SID.SWHYDJXXHYSF,
                ProxyConstants.RID.QSBDC_RID, appkey);
        String gjzwfwpt_rtime = GjzwfwptSignUtil.getGjzwfwptRtime(appkey);
        // 接口调用
        Map<String, Object> postParams = new HashMap<>();
        //组装参数
        //公共请求参数
        postParams.put("version","1.0");
        //请求查询条件参数
        JSONObject params = new JSONObject();
        params.putOnce("name_man", name_man);
        params.putOnce("cert_num_man", cert_num_man);
        params.putOnce("name_woman", name_woman);
        params.putOnce("cert_num_woman", cert_num_woman);
        postParams.put("biz_content", params.toString());
        return postRequest(ProxyConstants.SID.SWHYDJXXHYSF, gjzwfwpt_sign, gjzwfwpt_rtime, postParams);
    }

    //民政部_涉外婚姻登记信息核验(双方)(新)
    @ApiOperation(value = "民政部_涉外婚姻登记信息核验(双方)(新) ")
    @GetMapping("/swhydjxxhysfx")
    public AjaxResult swhydjxxhysfx(
            @ApiParam(value = "男方姓名") @RequestParam String name_man,
            @ApiParam(value = "男方身份证件号码") @RequestParam String cert_num_man,
            @ApiParam(value = "女方姓名") @RequestParam String name_woman,
            @ApiParam(value = "女方身份证件号码") @RequestParam String cert_num_woman) {

        if(StringUtils.isEmpty(name_man) || StringUtils.isEmpty(cert_num_man)){
            AjaxResult.error("请将参数填写完整");
        }
        if(StringUtils.isEmpty(name_woman) || StringUtils.isEmpty(cert_num_woman)){
            AjaxResult.error("请将参数填写完整");
        }

        String appkey = "24289506f7b4b5c5f5708bbdd73cb761"; //发送方签名
        String gjzwfwpt_sign = GjzwfwptSignUtil.getGjzwfwptSign(ProxyConstants.SID.SWHYDJXXHYSFX,
                ProxyConstants.RID.QSBDC_RID, appkey);
        String gjzwfwpt_rtime = GjzwfwptSignUtil.getGjzwfwptRtime(appkey);
        // 接口调用
        Map<String, Object> postParams = new HashMap<>();
        //组装参数
        //公共请求参数
        postParams.put("version","1.0");
        //请求查询条件参数
        JSONObject params = new JSONObject();
        params.putOnce("name_man", name_man);
        params.putOnce("cert_num_man", cert_num_man);
        params.putOnce("name_woman", name_woman);
        params.putOnce("cert_num_woman", cert_num_woman);
        postParams.put("biz_content", params.toString());

        String json = postRequest(ProxyConstants.SID.SWHYDJXXHYSFX, gjzwfwpt_sign, gjzwfwpt_rtime, postParams);

        Map<String, Object> jsonObject = JSONUtil.toBean(json,HashMap.class);
        Map<String, Object> map = (Map<String, Object>) jsonObject.get("biz_data");

        return AjaxResult.success("成功",map.get("result"));
    }

    //民政部_收养登记证信息（国内）查询
    @ApiOperation(value = "民政部_收养登记证信息（国内）查询")
    @GetMapping("/sydjxxgncx")
    public AjaxResult sydjxxgncx(
            @ApiParam(value = "查询方式:1	根据登记证号查询,\r\n"
                    + "2	根据男收养人姓名和男收养人身份证号查询,\r\n"
                    + "3	根据女收养人姓名和女收养人身份证号查询,\r\n"
                    + "4	根据被收养人姓名和被收养人身份证号查询", allowableValues = "1,2,3,4") @RequestParam String querytype,
            @ApiParam(value = "证件号码") @RequestParam String reqcert_num,
            @ApiParam(value = "姓名") @RequestParam(required = false) String name) {

        if(StringUtils.isEmpty(querytype) || StringUtils.isEmpty(reqcert_num) || StringUtils.isEmpty(name)){
            AjaxResult.error("请将参数填写完整");
        }

        String appkey = "e8c6e754492a296ecad061a3917ad3c1"; //发送方签名
        String gjzwfwpt_sign = GjzwfwptSignUtil.getGjzwfwptSign(ProxyConstants.SID.SYDJXXGNCX,
                ProxyConstants.RID.QSBDC_RID, appkey);
        String gjzwfwpt_rtime = GjzwfwptSignUtil.getGjzwfwptRtime(appkey);
        // 接口调用
        Map<String, Object> postParams = new HashMap<>();
        //组装参数
        //公共请求参数
        postParams.put("version","");
        //请求查询条件参数
        JSONObject params = new JSONObject();
        //查询条件，以下4种查询条件选择一种
        //1.按登记证号查询
        params.putOnce("querytype", querytype);
        params.putOnce("cert_num", reqcert_num);
        params.putOnce("name", name);
        postParams.put("biz_content", params.toString());

        String json = postRequest(ProxyConstants.SID.SYDJXXGNCX, gjzwfwpt_sign, gjzwfwpt_rtime, postParams);

        Map<String, Object> jsonObject = JSONUtil.toBean(json,HashMap.class);
        Map<String, Object> map = (Map<String, Object>) jsonObject.get("biz_data");

        return AjaxResult.success("成功",map.get("result"));
    }


    // Rest post接口
    private String postRequest(String sid, String gjzwfwpt_sign,
                               String gjzwfwpt_rtime, Map<String, Object> postParams) {
        postParams.put("access_key", "AH34");
        postParams.put("format", "json");
        postParams.put("request_id", "");
        postParams.put("sign", "aaaa");
        postParams.put("timestamp", gjzwfwpt_rtime);
        return HttpRequest.post(ProxyConstants.URL.REST_URL)
                .form(postParams)
                .header("gjzwfwpt_rid", ProxyConstants.RID.QSBDC_RID)
                .header("gjzwfwpt_sid", sid)
                .header("gjzwfwpt_sign", gjzwfwpt_sign)
                .header("gjzwfwpt_rtime", gjzwfwpt_rtime)
                .header("connection", "Keep-Alive")
                .header("user-agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1;SV1)")
                .header("Content-Type","application/x-www-form-urlencoded")
                .timeout(20000)//超时，毫秒
                .execute().body();
    }

    // webservice post接口
    private String postServiceRequest(String sid, String gjzwfwpt_sign,
                                      String gjzwfwpt_rtime, String body) {

        return HttpRequest.post(ProxyConstants.URL.REST_URL)
                .body(body)
                .header("gjzwfwpt_rid", ProxyConstants.RID.QSBDC_RID)
                .header("gjzwfwpt_sid", sid)
                .header("gjzwfwpt_sign", gjzwfwpt_sign)
                .header("gjzwfwpt_rtime", gjzwfwpt_rtime)
                .header("connection", "Keep-Alive")
                .header("user-agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1;SV1)")
                .header("Content-Type","text/xml")
                .timeout(20000)//超时，毫秒
                .execute().body();
    }
}
