package com.boman.web.core.domain;

import com.boman.domain.BaseEntity;
import com.boman.domain.annotation.Excel;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import java.util.Date;

/**
 * 中考下发短信日志对象 send_sms
 * 
 * @author boman
 * @date 2022-07-11
 */
public class SendSms extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** $column.columnComment */
    private Long id;

    /** 发送的手机号 */
    @Excel(name = "手机号")
    private String phone;
    /**
     * 准考证号码
     */
    @Excel(name = "准考证号码")
    private String ticketId;
    /**
     * 姓名
     */
    @Excel(name = "姓名")
    private String name;
    /**
     * 年份
     */
    @Excel(name = "年份")
    private String year;
    @Excel(name = "语文")
    private String chinese;
    @Excel(name = "数学")
    private String mathematics;
    @Excel(name = "英语")
    private String english;
    @Excel(name = "道德与法治")
    private String morality;
    @Excel(name = "历史")
    private String history;
    @Excel(name = "物理")
    private String physics;
    @Excel(name = "化学")
    private String chemistry;
    @Excel(name = "体育")
    private String culture;
    @Excel(name = "实验")
    private String experiment;
    @Excel(name = "照顾分")
    private String policy;
    @Excel(name = "总分")
    private String score;
    @Excel(name = "短信模板")
    private String templateCode;

    /**
     *录取结果
     */
    @Excel(name = "录取结果")
    private String result;



    /** 状态 */
    @Excel(name = "状态")
    private String status;

    /** 发送内容 */
    @Excel(name = "发送内容")
    private String content;

    /** 修改时间 */
    private String modifyDate;

    /**
     * 模板名称
     */
    private String templateName;

    /** 是否删除 */
    private String isDel;
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;

    public String getTemplateCode() {
        return templateCode;
    }

    public void setTemplateCode(String templateCode) {
        this.templateCode = templateCode;
    }

    public String getYear() {
        return year;
    }

    public void setYear(String year) {
        this.year = year;
    }

    public String getChinese() {
        return chinese;
    }

    public void setChinese(String chinese) {
        this.chinese = chinese;
    }

    public String getMathematics() {
        return mathematics;
    }

    public void setMathematics(String mathematics) {
        this.mathematics = mathematics;
    }

    public String getEnglish() {
        return english;
    }

    public void setEnglish(String english) {
        this.english = english;
    }

    public String getMorality() {
        return morality;
    }

    public void setMorality(String morality) {
        this.morality = morality;
    }

    public String getHistory() {
        return history;
    }

    public void setHistory(String history) {
        this.history = history;
    }

    public String getPhysics() {
        return physics;
    }

    public void setPhysics(String physics) {
        this.physics = physics;
    }

    public String getChemistry() {
        return chemistry;
    }

    public void setChemistry(String chemistry) {
        this.chemistry = chemistry;
    }

    public String getCulture() {
        return culture;
    }

    public void setCulture(String culture) {
        this.culture = culture;
    }

    public String getExperiment() {
        return experiment;
    }

    public void setExperiment(String experiment) {
        this.experiment = experiment;
    }

    public String getPolicy() {
        return policy;
    }

    public void setPolicy(String policy) {
        this.policy = policy;
    }

    public String getScore() {
        return score;
    }

    public void setScore(String score) {
        this.score = score;
    }

    @Override
    public Date getCreateTime() {
        return createTime;
    }

    @Override
    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public String getTicketId() {
        return ticketId;
    }

    public void setTicketId(String ticketId) {
        this.ticketId = ticketId;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getResult() {
        return result;
    }

    public void setResult(String result) {
        this.result = result;
    }

    public String getTemplateName() {
        return templateName;
    }

    public void setTemplateName(String templateName) {
        this.templateName = templateName;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public void setPhone(String phone)
    {
        this.phone = phone;
    }

    public String getPhone() 
    {
        return phone;
    }
    public void setStatus(String status) 
    {
        this.status = status;
    }

    public String getStatus() 
    {
        return status;
    }
    public void setContent(String content) 
    {
        this.content = content;
    }

    public String getContent() 
    {
        return content;
    }
    public void setModifyDate(String modifyDate) 
    {
        this.modifyDate = modifyDate;
    }

    public String getModifyDate() 
    {
        return modifyDate;
    }
    public void setIsDel(String isDel) 
    {
        this.isDel = isDel;
    }

    public String getIsDel() 
    {
        return isDel;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this,ToStringStyle.MULTI_LINE_STYLE)
            .append("id", getId())
            .append("phone", getPhone())
            .append("status", getStatus())
            .append("content", getContent())
            .append("modifyDate", getModifyDate())
            .append("createBy", getCreateBy())
            .append("createTime", getCreateTime())
            .append("updateBy", getUpdateBy())
            .append("updateTime", getUpdateTime())
            .append("isDel", getIsDel())
            .toString();
    }
}
