package com.boman.web.core.mapper;

import java.util.List;
import com.boman.web.core.domain.SendSms;

/**
 * 中考下发短信日志Mapper接口
 * 
 * @author boman
 * @date 2022-07-11
 */
public interface SendSmsMapper 
{
    /**
     * 查询中考下发短信日志
     * 
     * @param id 中考下发短信日志主键
     * @return 中考下发短信日志
     */
    public SendSms selectSendSmsById(String id);

    /**
     * 查询中考下发短信日志列表
     * 
     * @param sendSms 中考下发短信日志
     * @return 中考下发短信日志集合
     */
    public List<SendSms> selectSendSmsList(SendSms sendSms);

    /**
     * 新增中考下发短信日志
     * 
     * @param sendSms 中考下发短信日志
     * @return 结果
     */
    public int insertSendSms(SendSms sendSms);

    /**
     * 修改中考下发短信日志
     * 
     * @param sendSms 中考下发短信日志
     * @return 结果
     */
    public int updateSendSms(SendSms sendSms);

    /**
     * 删除中考下发短信日志
     * 
     * @param id 中考下发短信日志主键
     * @return 结果
     */
    public int deleteSendSmsById(String id);

    /**
     * 批量删除中考下发短信日志
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteSendSmsByIds(String[] ids);
}
